#lang racket

;;;; 10. cvičenie z predmetu 2-AIN-285 Symbolické programovanie a LISP
;;;;
;;;; Meno a priezvisko:
;;;; Verzia DrRacket: 6.10.1
;;;; Dátum: 14.5.2018
;;;; WWW: http://www.ii.fmph.uniba.sk/cl/view.php/courses/2-AIN-285-lisp/1718ls/?lang=sk 
;;;; Kontakt: Jan.Komara(at)fmph.uniba.sk 
;;;;
;;;; Úvodná poznámka. Toto cvičenie je venované týmto témam:
;;;; - nekonečné streamy.
;;;; Zadanie sa skladá z týchto súborov: 
;;;; - Súbory maux*.rkt obsahujú definície pomocných funkcií a predikátov. 
;;;; - Súbory ex*.rkt obsahujú úlohy, ktoré máte riešiť na tomto cvičení.
;;;;
;;;; Hodnotenie.
;;;; - Počet bodov za úlohy v tomto súbore: 0
;;;; - Počet bodov za prémiove úlohy v tomto súbore: 10
;;;; - Počet bodov za projektové úlohy v tomto súbore: 0
;;;; Odovzdať do 18.5.2018 (nedeľa) do 12:00.

;; [Lisp]

(require racket/undefined)
(define ... undefined)
(require math/base math/number-theory)

;; Literatúra.
;; [1] Hal Abelson and Jerry Sussman and Julie Sussman.
;;     Structure and Interpretation of Computer Programs.
;;     MIT Press, second edition, 1996. 

;;; Kapitola. Streamy.

;;; Sekcia. Nekonečné streamy.

;;; Podsekcia. Implementácia.

;; [Lisp] Pozri modul v súbore maux.rkt.

(require "maux.rkt")

;; Definícia.
;; Ak s je stream, tak symbolom range(s) označujeme množinu jeho prvkov. Vravíme
;; tiež, že stream s enumeruje množinu range(s). Ak v streame s sa nevyskytujú
;; rovnaké prvky, tak ide o enumeráciu bez opakovania. Stream často nefomálne
;; popisujeme vymenovaním niektorých jeho prvkov:
;;   s = (s[0], s[1], s[2], ..., s[i], ...).
;; Tu s[0] je prvý prvok streamu s, s[1] je druhý prvok streamu s, atď.

;;; Podsekcia. [Lisp]

;; Táto časť slúži pre ladenie. Nehodnotí sa!

;; Náhodný generátor (nekonečných) streamov celých čísel.

(define (random-integer-stream m n)
  (scons (random-integer m n)
         (random-integer-stream m n)))

;; Aplikácia stream->list(n,s) vráti zoznam prvých n prvkov streamu s.

(define (stream->list n s)
  (if (= n 0)
      '()
      (cons (scar s)
            (stream->list (- n 1) (scdr s)))))

;; (stream->list 10 (random-integer-stream 0 10))

;; Aplikácia stream-ref(s,i) vráti prvok streamu s na pozícii s indexom (i+1).
;; Indexuje sa od nuly.
;;   M-syntax: s[i].

(define (stream-ref s i)
  (if (= i 0)
      (scar s)
      (stream-ref (scdr s) (- i 1))))

;; (let ([s (random-integer-stream 0 10)] [i 5]) (writeln (stream->list 10 s)) (writeln (stream-ref s i)))

;; Užitočné pri ladení programu spracuvajúceho dva streamy.

(define (query-proc-two-streams proc length m n)
  (let ([s1 (random-integer-stream m n)]
        [s2 (random-integer-stream m n)])
    (writeln (stream->list length s1))
    (writeln (stream->list length s2))
    (writeln (stream->list length (proc s1 s2)))))

;;; Podsekcia. Príklady jednoduchých streamov.

;; Úloha.
;; Zostrojte program pre funkciu constant(item), ktorá vráti konštantný stream
;; obsahujúci prvok item:
;;   range constant(item) = {item}.

(define (constant item) ...)

;; (stream->list 10 (constant 1))

;; Úloha.
;; Zostrojte stream integers-starting-from(n), ktorý enumeruje množinu celých
;; čísel väčších alebo rovných číslu n, a to takto:
;;   integers-starting-from(n) = (n, n+1, n+2, ...).

(define (integers-starting-from n) ...)

;; (stream->list 10 (integers-starting-from (- 5)))

;; Úloha.
;; Zostrojte stream, ktorý enumeruje množinu prirodzených čísel N v prirodzenom
;; poradí: (0, 1, 2, ...).

(define natural-numbers ...)

;; (stream->list 10 natural-numbers)

;; Úloha.
;; Zostrojte stream, ktorý enumeruje množinu kladných celých čísel v prirodzenom
;; poradí: (1, 2, 3, ...).

(define positive-integers ...)

;; (stream->list 10 positive-integers)

;;; Podsekcia. Základné operácie na streamoch.

;; Úloha.
;; Zostrojte program pre funkcionál stream-map, ktorý funguje na streamoch
;; podobne ako funkcionál map na zoznamoch.

(define (stream-map proc s) ...)

;; (stream->list 10 (stream-map (λ (x) 1) natural-numbers))
;; (stream->list 10 (stream-map (λ (x) (+ x (- 5))) natural-numbers))
;; (stream->list 10 (stream-map (λ (x) (+ x 1)) natural-numbers))
;; (stream->list 10 (stream-map (λ (x) (* x x)) natural-numbers))

;; Úloha.
;; Zostrojte program pre funkciu multiples-of(n), ktorá vytvorí stream
;; enumerujúci množinu nezáporných celočíselných násobkov čísla n:
;;   multiples-of(n) = {0, n , 2n, 3n, 4n, ...}.
;; Pokyny. Použite operáciu stream-map.

(define (multiples-of n) ...)

;; Úloha.
;; Zostrojte program pre funkcionál stream-filter, ktorý funguje na streamoch
;; podobne ako funkcionál filter na zoznamoch.

(define (stream-filter pred s) ...)

;; (stream->list 10 (stream-filter prime? natural-numbers))

;; Úloha.
;; (prémia 2 body)
;; Implementujte Eratostenovo sito pomocou streamov.
;; Pokyny. Použite operáciu stream-filter.

(define (sieve s) ...)
(define primes ...)
  
;; (stream->list 10 primes)
;; (stream-ref primes 50)

;; Úloha.
;; Zostrojte program pre funkciu add-streams(s1,s2), ktorá sčíta danú dvojicu
;; streamov po zložkách:
;;   add-streams(s1,s2)[i] = s1[i]+s2[i].

(define (add-streams s1 s2) ...)

;; (stream->list 10 (add-streams (constant 1) (constant 2)))
;; (query-proc-two-streams add-streams 10 0 10)

;; Úloha.
;; Zostrojte stream triangular-numbers, ktorý enumeruje množinu trojuholníkových
;; čísel, a to takto:
;;   triangular-numbers[n] = 0+1+2+⋯+n.
;; Pokyny. Využite operáciu add-streams. Použite nasledovnú schému:

(define triangular-numbers
  (scons ... (add-streams ... ...)))

;; (stream->list 10 triangular-numbers)

;; Úloha.
;; Zostrojte stream fibonacci-numbers, ktorý enumeruje množinu Fibonacciho čísel,
;; a to takto:
;;   fibonacci-numbers = (0, 1, 1, 2, 3, 5, 8, 13, 21, 34, ...).
;; Pokyny. Použite podobnú schému ako v predchadzajúcom príklade.

(define fibonacci-numbers ...)

;; (stream->list 10 fibonacci-numbers)

;; Úloha.
;; Zostrojte program pre funkciu partial-sums, ktorá vráti stream, ktorého n-tý
;; prvok je súčtom prvých n prvkov vstupného streamu:
;;   (partial-sums(s))[n] = s[0]+s[1]+s[2]+⋯+s[n].
;; Pokyny. Použite podobnú schému ako v predchadzajúcich príkladoch.

(define (partial-sums s) ...)

;; (stream->list 10 (partial-sums natural-numbers))
;; (let ([s (random-integer-stream 0 10)]) (writeln (stream->list 10 s)) (writeln (stream->list 10 (partial-sums s))))

;; Úloha.
;; Zostrojte program pre funkciu mul-streams(s1,s2), ktorá vynásobí danú dvojicu
;; streamov po zložkách:
;;   mul-streams(s1,s2)[i] = s1[i]×s2[i].

(define (mul-streams s1 s2) ...)

;; (stream->list 10 (mul-streams (scdream 2) (constant 3)))
;; (query-proc-two-streams mul-streams 10 0 10)

;; Úloha.
;; Zostrojte stream, ktorý enumeruje množinu faktoriálov:
;;   range(factorials) = {0!, 1!, 2!, ..., n!, ...}.
;; Pokyny. Využite operáciu mul-streams. Použite nasledovnú schému:

(define factorials
  (scons ... (mul-streams ... ...)))

;; (stream->list 10 factorials)

;; Úloha.
;; Zostrojte stream, ktorý enumeruje množinu pozostávajúcu z mocnín čísla 2:
;;   range(powers-of-two) = {1, 2, 4, ..., 2^n, ...}.
;; Pokyny. Použite podobnú schému ako v predchadzajúcom príklade.

(define powers-of-two ...)

;; (stream->list 10 powers-of-two)

;; Úloha.
;; Zostrojte program pre funkciu powers-of(b), ktorá vytvorí stream enumerujúci
;; množinu mocnín čísla b:
;;   range powers-of(b) = {1, b, b^2, ..., b^n, ...}.
;; Pokyny. Použite podobnú schému ako v predchadzajúcich príkladoch.

(define (powers-of b) ...)

;; (stream->list 10 (powers-of 2))
;; (stream->list 10 (powers-of 3))

;; (prémia 3 body)
;; Úloha.
;; Zostrojte systém streamov powers-of-primes, ktorý pozostáva z mocnín prvočísel:
;;   range(powers-of-primes[0]) = {1, 2, 4, ..., 2^n, ...}
;;   range(powers-of-primes[1]) = {1, 3, 9, ..., 3^n, ...}
;;   range(powers-of-primes[2]) = {1, 5, 25, ..., 5^n, ...}
;;   ...
;; Systémom streamov tu rozumieme stream, ktorého každý člen je opäť stream.

(define powers-of-primes ...)

;; (stream->list 10 powers-of-primes)
;; (stream->list 10 (stream-ref powers-of-primes 0))
;; (stream->list 10 (stream-ref powers-of-primes 1))
;; (stream->list 10 (stream-ref powers-of-primes 2))

;;; Podsekcia. Množinové operácie na streamoch.

;; (prémia 1 bod)
;; Úloha.
;; Zostrojte stream, ktorý enumeruje bez opakovania množinu celých čísel Z.
;;   range(integers) = {.., -2, -1, 0, 1, 2, ...}.

(define integers ...)

;; (stream->list 10 integers)

;; Úloha.
;; Zostrojte program pre funkciu union-streams(s1,s2), ktorá zjednotí danú
;; dvojicu streamov:
;;   range union-streams(s1,s2) = range(s1) ∪ range(s2).

(define (union-streams s1 s2) ...)

;; (stream->list 10 (union-streams (constant 1) (constant 2)))
;; (stream->list 10 (union-streams factorials powers-of-two))

;; Úloha.
;; Zostrojte program, ktorý vyhodí duplikáty zo streamu. Predpokladajte, že
;; vstupný stream enumeruje nekonečnú množinu.
;; Pokyny. Použite operáciu stream-filter.

(define (no-doubles s) ...)

;; (stream->list 10 (no-doubles (union-streams (multiples-of 2) (multiples-of 3))))

;; (prémia 4 body)
;; Úloha.
;; Zostrojte stream, ktorý enumeruje karteziánsky súčin N×N.
;; Pokyny. Nepoužívajte párovaciu funkciu.
;; Návod. Enumeráciu N×N navrhnite takto:
;;     |  0  1  2  3  4
;;   -------------------
;;   0 |  1  2  4  7 11
;;   1 |  3  5  8 12 17
;;   2 |  6  9 13 18 24
;;   3 | 10 14 19 25 32
;;   4 | 15 20 26 33 41

(define natural-numbers×natural-numbers ...)

;; (stream->list 20 natural-numbers×natural-numbers)
